diff -ruN vdr-2.3.4/ci.h vdr-2.3.5/ci.h
--- vdr-2.3.4/ci.h	2017-04-10 11:17:56.000000000 +0200
+++ vdr-2.3.5/ci.h	2017-05-16 09:42:45.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.h 4.6 2017/04/10 09:17:56 kls Exp $
+ * $Id: ci.h 4.9 2017/05/16 07:42:45 kls Exp $
  */
 
 #ifndef __CI_H
@@ -21,6 +21,99 @@
 #define MAX_CONNECTIONS_PER_CAM_SLOT  8 // maximum possible value is 254
 #define CAM_READ_TIMEOUT  50 // ms
 
+class cCiTransportConnection;
+class cCamSlot;
+
+// VDR's Common Interface functions implement only the features that are absolutely
+// necessary to control a CAM. If a plugin wants to implement additional functionality
+// (i.e. "resources"), it can do so by deriving from cCiResourceHandler, cCiSession
+// and (if necessary) from cCiApplicationInformation.
+
+class cCiSession {
+private:
+  uint16_t sessionId;
+  uint32_t resourceId;
+  cCiTransportConnection *tc;
+protected:
+  void SetTsPostProcessor(void);
+       ///< If this cCiSession implements the TsPostProcess() function, it shall call
+       ///< SetTsPostProcessor() to register itself as the TS post processor.
+  void SetResourceId(uint32_t Id);
+       ///< If this is a class that has been derived from an existing cCiSession class,
+       ///< but implements a different resource id, it shall call SetResourceId() with
+       ///< that Id.
+  int GetTag(int &Length, const uint8_t **Data);
+  const uint8_t *GetData(const uint8_t *Data, int &Length);
+  void SendData(int Tag, int Length = 0, const uint8_t *Data = NULL);
+  cCiTransportConnection *Tc(void) { return tc; }
+public:
+  cCiSession(uint16_t SessionId, uint32_t ResourceId, cCiTransportConnection *Tc);
+  virtual ~cCiSession();
+  uint16_t SessionId(void) { return sessionId; }
+  uint32_t ResourceId(void) { return resourceId; }
+  cCamSlot *CamSlot(void);
+  virtual bool HasUserIO(void) { return false; }
+  virtual void Process(int Length = 0, const uint8_t *Data = NULL);
+  virtual bool TsPostProcess(uint8_t *TsPacket) { return false; }
+       ///< If this cCiSession needs to do additional processing on TS packets (after
+       ///< the CAM has done the decryption), it shall implement TsPostProcess() and
+       ///< do whatever operations are necessary on the given TsPacket. This function
+       ///< is called once for each TS packet, and any and all operations must be
+       ///< finished upon return.
+       ///< A derived cCiSession that implements this function must call
+       ///< SetTsPostProcessor() to make it actually get called.
+       ///< Returns true if the TsPacket was in any way modified.
+  };
+
+class cCiApplicationInformation : public cCiSession {
+protected:
+  int state;
+  uint8_t applicationType;
+  uint16_t applicationManufacturer;
+  uint16_t manufacturerCode;
+  char *menuString;
+public:
+  cCiApplicationInformation(uint16_t SessionId, cCiTransportConnection *Tc);
+  virtual ~cCiApplicationInformation();
+  virtual void Process(int Length = 0, const uint8_t *Data = NULL);
+  bool EnterMenu(void);
+  const char *GetMenuString(void) { return menuString; }
+  };
+
+class cCiResourceHandler : public cListObject {
+public:
+  cCiResourceHandler(void);
+       ///< Creates a new resource handler, through which the available resources
+       ///< can be provides. A resource handler shall be allocated on the heap and
+       ///< registered with the global CiResourceHandlers, as in
+       ///< CiResourceHandlers.Register(new cMyResourceHandler);
+       ///< It will be automatically deleted at the end of the program.
+  virtual ~cCiResourceHandler();
+  virtual const uint32_t *ResourceIds(void) const = 0;
+       ///< Returns a pointer to an array of resource identifiers, where the
+       ///< last value is zero.
+  virtual cCiSession *GetNewCiSession(uint32_t ResourceId, uint16_t SessionId, cCiTransportConnection *Tc) = 0;
+       ///< Returns a new cCiSession, according to the given ResourceId.
+  };
+
+class cCiResourceHandlers : public cList<cCiResourceHandler> {
+private:
+  cVector<uint32_t> resourceIds;
+public:
+  cCiResourceHandlers(void);
+       ///< Creates the default list of resourceIds.
+  void Register(cCiResourceHandler *ResourceHandler);
+       ///< Adds the given ResourceHandler to the list of resource handlers and
+       ///< appends its ResourceIds to the global resourceIds.
+       ///< A plugin that implements additional CAM capabilities must call
+       ///< this function to register its resources.
+  const uint32_t *Ids(void) { return &resourceIds[0]; }
+  int NumIds(void) { return resourceIds.Size(); }
+  cCiSession *GetNewCiSession(uint32_t ResourceId, uint16_t SessionId, cCiTransportConnection *Tc);
+  };
+
+extern cCiResourceHandlers CiResourceHandlers;
+
 class cCiMMI;
 
 class cCiMenu {
@@ -73,7 +166,6 @@
   };
 
 class cDevice;
-class cCamSlot;
 
 enum eModuleStatus { msNone, msReset, msPresent, msReady };
 
@@ -377,6 +469,24 @@
        ///< A derived class that implements this function will also need
        ///< to set the WantsTsData parameter in the call to the base class
        ///< constructor to true in order to receive the TS data.
+  virtual bool TsPostProcess(uchar *Data);
+       ///< If there is a cCiSession that needs to do additional processing on TS packets
+       ///< (after the CAM has done the decryption), this function will call its
+       ///< TsPostProcess() function to have it do whatever operations are necessary on
+       ///< the given TsPacket.
+       ///< Returns true if the TsPacket was in any way modified.
+  virtual bool Inject(uchar *Data, int Count);
+       ///< Sends all Count bytes of the given Data to the CAM, and returns true
+       ///< if this was possible. If the data can't be sent to the CAM completely,
+       ///< nothing shall be sent and the return value shall be false.
+       ///< No decrypted packet is returned by this function.
+       ///< Data is guaranteed to point to one or more complete TS packets.
+  virtual void InjectEit(int Sid);
+       ///< Injects a generated EIT with a "present event" for the given Sid into
+       ///< the TS data stream sent to the CAM. This only applies to CAM slots that
+       ///< have WantsTsData set to true in their constructor.
+       ///< The default implementation sends an EIT with the minimum event
+       ///< necessary to disable the CAMs parental rating prompt.
   };
 
 class cCamSlots : public cList<cCamSlot> {
diff -ruN vdr-2.3.4/config.c vdr-2.3.5/config.c
--- vdr-2.3.4/config.c	2017-02-14 12:02:48.000000000 +0100
+++ vdr-2.3.5/config.c	2017-05-21 12:25:26.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 4.5 2017/02/14 11:02:48 kls Exp $
+ * $Id: config.c 4.6 2017/05/21 10:25:26 kls Exp $
  */
 
 #include "config.h"
@@ -640,7 +640,7 @@
   else if (!strcasecmp(Name, "EPGLinger"))           EPGLinger          = atoi(Value);
   else if (!strcasecmp(Name, "SVDRPTimeout"))        SVDRPTimeout       = atoi(Value);
   else if (!strcasecmp(Name, "SVDRPPeering"))        SVDRPPeering       = atoi(Value);
-  else if (!strcasecmp(Name, "SVDRPHostName"))     { if (!*SVDRPHostName) strn0cpy(SVDRPHostName, Value, sizeof(SVDRPHostName)); }
+  else if (!strcasecmp(Name, "SVDRPHostName"))     { if (*Value) strn0cpy(SVDRPHostName, Value, sizeof(SVDRPHostName)); }
   else if (!strcasecmp(Name, "SVDRPdefaultHost"))    strn0cpy(SVDRPDefaultHost, Value, sizeof(SVDRPDefaultHost));
   else if (!strcasecmp(Name, "ZapTimeout"))          ZapTimeout         = atoi(Value);
   else if (!strcasecmp(Name, "ChannelEntryTimeout")) ChannelEntryTimeout= atoi(Value);
@@ -771,7 +771,7 @@
   Store("EPGLinger",          EPGLinger);
   Store("SVDRPTimeout",       SVDRPTimeout);
   Store("SVDRPPeering",       SVDRPPeering);
-  Store("SVDRPHostName",      SVDRPHostName);
+  Store("SVDRPHostName",      strcmp(SVDRPHostName, GetHostName()) ? SVDRPHostName : "");
   Store("SVDRPDefaultHost",   SVDRPDefaultHost);
   Store("ZapTimeout",         ZapTimeout);
   Store("ChannelEntryTimeout",ChannelEntryTimeout);
diff -ruN vdr-2.3.4/config.h vdr-2.3.5/config.h
--- vdr-2.3.4/config.h	2017-03-30 15:42:15.000000000 +0200
+++ vdr-2.3.5/config.h	2017-04-29 15:33:13.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 4.8 2017/03/30 13:42:15 kls Exp $
+ * $Id: config.h 4.9 2017/04/29 13:33:13 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "2.3.4"
-#define VDRVERSNUM   20304  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "2.3.5"
+#define VDRVERSNUM   20305  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "2.3.4"
-#define APIVERSNUM   20304  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "2.3.5"
+#define APIVERSNUM   20305  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
diff -ruN vdr-2.3.4/cutter.c vdr-2.3.5/cutter.c
--- vdr-2.3.4/cutter.c	2015-08-09 14:24:28.000000000 +0200
+++ vdr-2.3.5/cutter.c	2017-05-21 11:45:06.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: cutter.c 4.2 2015/08/09 12:24:28 kls Exp $
+ * $Id: cutter.c 4.3 2017/05/21 09:45:06 kls Exp $
  */
 
 #include "cutter.h"
@@ -500,7 +500,7 @@
          TsSetContinuityCounter(p, counter[Pid]);
          }
       else
-         counter[Pid] = TsGetContinuityCounter(p); // collect initial counters
+         counter[Pid] = TsContinuityCounter(p); // collect initial counters
       // Adjust PTS:
       int64_t Pts = TsGetPts(p, TS_SIZE);
       if (Pts >= 0) {
diff -ruN vdr-2.3.4/device.c vdr-2.3.5/device.c
--- vdr-2.3.4/device.c	2017-04-17 16:47:42.000000000 +0200
+++ vdr-2.3.5/device.c	2017-05-18 11:27:55.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 4.15 2017/04/17 14:47:42 kls Exp $
+ * $Id: device.c 4.22 2017/05/18 09:27:55 kls Exp $
  */
 
 #include "device.h"
@@ -293,6 +293,7 @@
              // to their individual severity, where the one listed first will make the most
              // difference, because it results in the most significant bit of the result.
              uint32_t imp = 0;
+             imp <<= 1; imp |= (LiveView && NumUsableSlots && !HasInternalCam) ? !ChannelCamRelations.CamDecrypt(Channel->GetChannelID(), CamSlots.Get(j)->MasterSlotNumber()) || ndr : 0; // prefer CAMs that are known to decrypt this channel for live viewing, if we don't need to detach existing receivers
              imp <<= 1; imp |= LiveView ? !device[i]->IsPrimaryDevice() || ndr : 0;                                  // prefer the primary device for live viewing if we don't need to detach existing receivers
              imp <<= 1; imp |= !device[i]->Receiving() && (device[i] != cTransferControl::ReceiverDevice() || device[i]->IsPrimaryDevice()) || ndr; // use receiving devices if we don't need to detach existing receivers, but avoid primary device in local transfer mode
              imp <<= 1; imp |= device[i]->Receiving();                                                               // avoid devices that are receiving
@@ -749,7 +750,7 @@
   return NULL;
 }
 
-bool cDevice::SignalStats(int &Valid, double *Strength, double *Cnr, double *BerPre, double *BerPost, double *Per) const
+bool cDevice::SignalStats(int &Valid, double *Strength, double *Cnr, double *BerPre, double *BerPost, double *Per, int *Status) const
 {
   return false;
 }
@@ -782,7 +783,7 @@
 bool cDevice::SwitchChannel(const cChannel *Channel, bool LiveView)
 {
   if (LiveView) {
-     isyslog("switching to channel %d (%s)", Channel->Number(), Channel->Name());
+     isyslog("switching to channel %d %s (%s)", Channel->Number(), *Channel->GetChannelID().ToString(), Channel->Name());
      cControl::Shutdown(); // prevents old channel from being shown too long if GetDevice() takes longer
      }
   for (int i = 3; i--;) {
@@ -833,6 +834,7 @@
 
 eSetChannelResult cDevice::SetChannel(const cChannel *Channel, bool LiveView)
 {
+  cMutexLock MutexLock(&mutexReceiver); // to avoid a race between SVDRP CHAN and HasProgramme()
   cStatus::MsgChannelSwitch(this, 0, LiveView);
 
   if (LiveView) {
@@ -945,6 +947,7 @@
 
 bool cDevice::HasProgramme(void) const
 {
+  cMutexLock MutexLock(&mutexReceiver); // to avoid a race between SVDRP CHAN and HasProgramme()
   return Replaying() || pidHandles[ptAudio].pid || pidHandles[ptVideo].pid;
 }
 
@@ -1651,7 +1654,8 @@
 }
 
 #define TS_SCRAMBLING_TIMEOUT     3 // seconds to wait until a TS becomes unscrambled
-#define TS_SCRAMBLING_TIME_OK    10 // seconds before a Channel/CAM combination is marked as known to decrypt
+#define TS_SCRAMBLING_TIME_OK     3 // seconds before a Channel/CAM combination is marked as known to decrypt
+#define EIT_INJECTION_TIME       10 // seconds for which to inject EIT event
 
 void cDevice::Action(void)
 {
@@ -1663,6 +1667,9 @@
               if (b) {
                  // Distribute the packet to all attached receivers:
                  Lock();
+                 cCamSlot *cs = CamSlot();
+                 if (cs)
+                    cs->TsPostProcess(b);
                  int Pid = TsPid(b);
                  bool IsScrambled = TsIsScrambled(b);
                  for (int i = 0; i < MAXRECEIVERS; i++) {
@@ -1671,7 +1678,7 @@
                         Receiver->Receive(b, TS_SIZE);
                         // Check whether the TS packet is scrambled:
                         if (Receiver->startScrambleDetection) {
-                           if (cCamSlot *cs = CamSlot()) {
+                           if (cs) {
                               int CamSlotNumber = cs->MasterSlotNumber();
                               if (Receiver->lastScrambledPacket < Receiver->startScrambleDetection)
                                  Receiver->lastScrambledPacket = Receiver->startScrambleDetection;
@@ -1697,6 +1704,18 @@
                                  }
                               }
                            }
+                        // Inject EIT event to avoid the CAMs parental rating prompt:
+                        if (Receiver->startEitInjection) {
+                           time_t Now = time(NULL);
+                           if (cCamSlot *cs = CamSlot()) {
+                              if (Now != Receiver->lastEitInjection) { // once per second
+                                 cs->InjectEit(Receiver->ChannelID().Sid());
+                                 Receiver->lastEitInjection = Now;
+                                 }
+                              }
+                           if (Now - Receiver->startEitInjection > EIT_INJECTION_TIME)
+                              Receiver->startEitInjection = 0;
+                           }
                         }
                      }
                  Unlock();
@@ -1755,6 +1774,10 @@
          Unlock();
          if (camSlot && Receiver->priority > MINPRIORITY) { // priority check to avoid an infinite loop with the CAM slot's caPidReceiver
             camSlot->StartDecrypting();
+            if (camSlot->WantsTsData()) {
+               Receiver->lastEitInjection = 0;
+               Receiver->startEitInjection = time(NULL);
+               }
             if (CamSlots.NumReadyMasterSlots() > 1) { // don't try different CAMs if there is only one
                Receiver->startScrambleDetection = time(NULL);
                Receiver->scramblingTimeout = TS_SCRAMBLING_TIMEOUT;
diff -ruN vdr-2.3.4/device.h vdr-2.3.5/device.h
--- vdr-2.3.4/device.h	2017-04-17 16:46:57.000000000 +0200
+++ vdr-2.3.5/device.h	2017-05-09 13:24:47.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 4.8 2017/04/17 14:46:57 kls Exp $
+ * $Id: device.h 4.9 2017/05/09 11:24:47 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -112,6 +112,14 @@
 #define DTV_STAT_VALID_BERPRE    0x0004
 #define DTV_STAT_VALID_BERPOST   0x0008
 #define DTV_STAT_VALID_PER       0x0010
+#define DTV_STAT_VALID_STATUS    0x0020
+
+#define DTV_STAT_HAS_NONE        0x0000
+#define DTV_STAT_HAS_SIGNAL      0x0001
+#define DTV_STAT_HAS_CARRIER     0x0002
+#define DTV_STAT_HAS_VITERBI     0x0004
+#define DTV_STAT_HAS_SYNC        0x0008
+#define DTV_STAT_HAS_LOCK        0x0010
 
 class cDevice : public cThread {
   friend class cLiveSubtitle;
@@ -291,13 +299,14 @@
          ///< move the satellite dish to the requested position (only applies to DVB-S
          ///< devices). If no positioner is involved, or this is not a DVB-S device,
          ///< NULL will be returned.
-  virtual bool SignalStats(int &Valid, double *Strength = NULL, double *Cnr = NULL, double *BerPre = NULL, double *BerPost = NULL, double *Per = NULL) const;
+  virtual bool SignalStats(int &Valid, double *Strength = NULL, double *Cnr = NULL, double *BerPre = NULL, double *BerPost = NULL, double *Per = NULL, int *Status = NULL) const;
          ///< Returns statistics about the currently received signal (if available).
          ///< Strength is the signal strength in dBm (typical range -100dBm...0dBm).
          ///< Cnr is the carrier to noise ratio in dB (typical range 0dB...40dB).
          ///< BerPre is the bit error rate before the forward error correction (FEC).
          ///< BerPost is the bit error rate after the forward error correction (FEC).
          ///< Per is the block error rate after the forward error correction (FEC).
+         ///< Status is the masked frontend status (signal/carrier/viterbi/sync/lock).
          ///< Typical range for BerPre, BerPost and Per is 0...1.
          ///< If any of the given pointers is not NULL, the value of the respective signal
          ///< statistic is returned in it. Upon return, Valid holds a combination of
diff -ruN vdr-2.3.4/dvbdevice.c vdr-2.3.5/dvbdevice.c
--- vdr-2.3.4/dvbdevice.c	2017-04-20 16:42:35.000000000 +0200
+++ vdr-2.3.5/dvbdevice.c	2017-05-09 13:50:38.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 4.9 2017/04/20 14:42:35 kls Exp $
+ * $Id: dvbdevice.c 4.13 2017/05/09 11:50:38 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -349,7 +349,7 @@
   void SetChannel(const cChannel *Channel);
   bool Locked(int TimeoutMs = 0);
   const cPositioner *Positioner(void) const { return positioner; }
-  bool GetSignalStats(int &Valid, double *Strength = NULL, double *Cnr = NULL, double *BerPre = NULL, double *BerPost = NULL, double *Per = NULL) const;
+  bool GetSignalStats(int &Valid, double *Strength = NULL, double *Cnr = NULL, double *BerPre = NULL, double *BerPost = NULL, double *Per = NULL, int *Status = NULL) const;
   int GetSignalStrength(void) const;
   int GetSignalQuality(void) const;
   };
@@ -574,14 +574,29 @@
                           }\
                      }
 
-bool cDvbTuner::GetSignalStats(int &Valid, double *Strength, double *Cnr, double *BerPre, double *BerPost, double *Per) const
+bool cDvbTuner::GetSignalStats(int &Valid, double *Strength, double *Cnr, double *BerPre, double *BerPost, double *Per, int *Status) const
 {
   ClearEventQueue();
+  fe_status_t FeStatus;
   dtv_property Props[MAXFRONTENDCMDS];
   dtv_properties CmdSeq;
   memset(&Props, 0, sizeof(Props));
   memset(&CmdSeq, 0, sizeof(CmdSeq));
   CmdSeq.props = Props;
+  Valid = DTV_STAT_VALID_NONE;
+  if (ioctl(fd_frontend, FE_READ_STATUS, &FeStatus) != 0) {
+     esyslog("ERROR: frontend %d/%d: %m", adapter, frontend);
+     return false;
+     }
+  if (Status) {
+     *Status = DTV_STAT_HAS_NONE;
+     if (FeStatus & FE_HAS_SIGNAL)  *Status |= DTV_STAT_HAS_SIGNAL;
+     if (FeStatus & FE_HAS_CARRIER) *Status |= DTV_STAT_HAS_CARRIER;
+     if (FeStatus & FE_HAS_VITERBI) *Status |= DTV_STAT_HAS_VITERBI;
+     if (FeStatus & FE_HAS_SYNC)    *Status |= DTV_STAT_HAS_SYNC;
+     if (FeStatus & FE_HAS_LOCK)    *Status |= DTV_STAT_HAS_LOCK;
+     Valid |= DTV_STAT_VALID_STATUS;
+     }
   if (Strength)   SETCMD(DTV_STAT_SIGNAL_STRENGTH, 0);
   if (Cnr)        SETCMD(DTV_STAT_CNR, 0);
   if (BerPre)   { SETCMD(DTV_STAT_PRE_ERROR_BIT_COUNT, 0);
@@ -594,7 +609,6 @@
      esyslog("ERROR: frontend %d/%d: %m", adapter, frontend);
      return false;
      }
-  Valid = DTV_STAT_VALID_NONE;
   int i = 0;
   if (Strength) {
      if (Props[i].u.st.len > 0) {
@@ -659,6 +673,7 @@
      }
 #ifdef DEBUG_SIGNALSTATS
   fprintf(stderr, "FE %d/%d: API5 %04X", adapter, frontend, Valid);
+  if ((Valid & DTV_STAT_VALID_STATUS)   != 0) fprintf(stderr, " STAT=%04X",     *Status);
   if ((Valid & DTV_STAT_VALID_STRENGTH) != 0) fprintf(stderr, " STR=%1.1fdBm",  *Strength);
   if ((Valid & DTV_STAT_VALID_CNR)      != 0) fprintf(stderr, " CNR=%1.1fdB",   *Cnr);
   if ((Valid & DTV_STAT_VALID_BERPRE)   != 0) fprintf(stderr, " BERPRE=%1.1e",  *BerPre);
@@ -844,13 +859,16 @@
               // be considered low even if there haven't been any more uncorrected bocks
               // for quite a while.
               Unc = lastUncDelta;
-              int t = time(NULL) - lastUncChange - 2;
-              if (t > 0)
-                 Unc >>= min(t, 32);
+              if (Unc > 0) {
+                 int t = time(NULL) - lastUncChange - 2;
+                 if (t > 0)
+                    Unc >>= min(t, int(sizeof(Unc) * 8 - 1));
+                 if (Unc == 0)
+                    lastUncDelta = 0;
 #ifdef DEBUG_SIGNALQUALITY
-              if (Unc > 0)
                  fprintf(stderr, "FE %d/%d: API3 UNC = %u\n", adapter, frontend, Unc);
 #endif
+                 }
               break;
               }
            if (errno != EINTR) {
@@ -1288,14 +1306,25 @@
   "ISDBC",
   "ATSC",
   "ATSCMH",
-  "DMBTH",
+  "DTMB",
   "CMMB",
   "DAB",
   "DVB-T2",
   "TURBO",
+  "DVB-C",
+  "DVB-C2",
   NULL
   };
 
+static const int DeliverySystemNamesMax = sizeof(DeliverySystemNames) / sizeof(DeliverySystemNames[0]) - 2; // -1 to get the maximum allowed index & -1 for the NULL => -2
+
+static const char *GetDeliverySystemName(int Index)
+{
+  if (Index > DeliverySystemNamesMax)
+     Index = 0;
+  return DeliverySystemNames[Index];
+};
+
 cDvbDevice::cDvbDevice(int Adapter, int Frontend)
 {
   adapter = Adapter;
@@ -1393,9 +1422,9 @@
 {
   if (dvbTuner) {
      if (dvbTuner->FrontendType() != SYS_UNDEFINED)
-        return DeliverySystemNames[dvbTuner->FrontendType()];
+        return GetDeliverySystemName(dvbTuner->FrontendType());
      if (numDeliverySystems)
-        return DeliverySystemNames[deliverySystems[0]]; // to have some reasonable default
+        return GetDeliverySystemName(deliverySystems[0]); // to have some reasonable default
      }
   return "";
 }
@@ -1526,7 +1555,7 @@
   if (numDeliverySystems > 0) {
      cString ds("");
      for (int i = 0; i < numDeliverySystems; i++)
-         ds = cString::sprintf("%s%s%s", *ds, i ? "," : "", DeliverySystemNames[deliverySystems[i]]);
+         ds = cString::sprintf("%s%s%s", *ds, i ? "," : "", GetDeliverySystemName(deliverySystems[i]));
      cString ms("");
      if (frontendInfo.caps & FE_CAN_QPSK)      { numModulations++; ms = cString::sprintf("%s%s%s", *ms, **ms ? "," : "", MapToUserString(QPSK, ModulationValues)); }
      if (frontendInfo.caps & FE_CAN_QAM_16)    { numModulations++; ms = cString::sprintf("%s%s%s", *ms, **ms ? "," : "", MapToUserString(QAM_16, ModulationValues)); }
@@ -1827,9 +1856,9 @@
   return dvbTuner ? dvbTuner->Positioner() : NULL;
 }
 
-bool cDvbDevice::SignalStats(int &Valid, double *Strength, double *Cnr, double *BerPre, double *BerPost, double *Per) const
+bool cDvbDevice::SignalStats(int &Valid, double *Strength, double *Cnr, double *BerPre, double *BerPost, double *Per, int *Status) const
 {
-  return dvbTuner ? dvbTuner->GetSignalStats(Valid, Strength, Cnr, BerPre, BerPost, Per) : false;
+  return dvbTuner ? dvbTuner->GetSignalStats(Valid, Strength, Cnr, BerPre, BerPost, Per, Status) : false;
 }
 
 int cDvbDevice::SignalStrength(void) const
diff -ruN vdr-2.3.4/dvbdevice.h vdr-2.3.5/dvbdevice.h
--- vdr-2.3.4/dvbdevice.h	2017-04-17 16:44:43.000000000 +0200
+++ vdr-2.3.5/dvbdevice.h	2017-05-09 13:24:47.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.h 4.3 2017/04/17 14:44:43 kls Exp $
+ * $Id: dvbdevice.h 4.4 2017/05/09 11:24:47 kls Exp $
  */
 
 #ifndef __DVBDEVICE_H
@@ -244,7 +244,7 @@
   virtual bool ProvidesEIT(void) const;
   virtual int NumProvidedSystems(void) const;
   virtual const cPositioner *Positioner(void) const;
-  virtual bool SignalStats(int &Valid, double *Strength = NULL, double *Cnr = NULL, double *BerPre = NULL, double *BerPost = NULL, double *Per = NULL) const;
+  virtual bool SignalStats(int &Valid, double *Strength = NULL, double *Cnr = NULL, double *BerPre = NULL, double *BerPost = NULL, double *Per = NULL, int *Status = NULL) const;
   virtual int SignalStrength(void) const;
   virtual int SignalQuality(void) const;
   virtual const cChannel *GetCurrentlyTunedTransponder(void) const;
diff -ruN vdr-2.3.4/eit.c vdr-2.3.5/eit.c
--- vdr-2.3.4/eit.c	2017-03-31 17:16:46.000000000 +0200
+++ vdr-2.3.5/eit.c	2017-05-03 10:58:41.000000000 +0200
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 4.2 2017/03/31 15:16:46 kls Exp $
+ * $Id: eit.c 4.3 2017/05/03 08:58:41 kls Exp $
  */
 
 #include "eit.h"
@@ -79,6 +79,7 @@
 
   bool Empty = true;
   bool Modified = false;
+  time_t LingerLimit = Now - Setup.EPGLinger * 60;
   time_t SegmentStart = 0;
   time_t SegmentEnd = 0;
   struct tm t = { 0 };
@@ -93,6 +94,9 @@
       // Drop bogus events - but keep NVOD reference events, where all bits of the start time field are set to 1, resulting in a negative number.
       if (StartTime == 0 || StartTime > 0 && Duration == 0)
          continue;
+      // Ignore events that ended before the "EPG linger time":
+      if (StartTime + Duration < LingerLimit)
+         continue;
       Empty = false;
       if (!SegmentStart)
          SegmentStart = StartTime;
diff -ruN vdr-2.3.4/eit.h vdr-2.3.5/eit.h
--- vdr-2.3.4/eit.h	2015-07-25 13:03:53.000000000 +0200
+++ vdr-2.3.5/eit.h	2017-05-08 23:10:29.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: eit.h 4.1 2015/07/25 11:03:53 kls Exp $
+ * $Id: eit.h 4.2 2017/05/08 21:10:29 kls Exp $
  */
 
 #ifndef __EIT_H
@@ -15,7 +15,10 @@
 
 class cSectionSyncerEntry : public cListObject, public cSectionSyncer {};
 
-class cSectionSyncerHash : public cHash<cSectionSyncerEntry> {};
+class cSectionSyncerHash : public cHash<cSectionSyncerEntry> {
+public:
+  cSectionSyncerHash(void) : cHash(HASHSIZE, true) {};
+  };
 
 class cEitFilter : public cFilter {
 private:
diff -ruN vdr-2.3.4/epg.c vdr-2.3.5/epg.c
--- vdr-2.3.4/epg.c	2017-04-02 13:34:15.000000000 +0200
+++ vdr-2.3.5/epg.c	2017-05-09 14:16:36.000000000 +0200
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 4.4 2017/04/02 11:34:15 kls Exp $
+ * $Id: epg.c 4.6 2017/05/09 12:16:36 kls Exp $
  */
 
 #include "epg.h"
@@ -529,15 +529,14 @@
   return true;
 }
 
-bool cEvent::Read(FILE *f, cSchedule *Schedule)
+bool cEvent::Read(FILE *f, cSchedule *Schedule, int &Line)
 {
   if (Schedule) {
      cEvent *Event = NULL;
      char *s;
-     int line = 0;
      cReadLine ReadLine;
      while ((s = ReadLine.Read(f)) != NULL) {
-           line++;
+           Line++;
            char *t = skipspace(s + 1);
            switch (*s) {
              case 'E': if (!Event) {
@@ -573,7 +572,7 @@
              case 'c': // to keep things simple we react on 'c' here
                        return true;
              default:  if (Event && !Event->Parse(s)) {
-                          esyslog("ERROR: EPG data problem in line %d", line);
+                          esyslog("ERROR: EPG data problem in line %d", Line);
                           return false;
                           }
              }
@@ -1098,7 +1097,7 @@
 {
   cEvent *Event;
   while ((Event = events.First()) != NULL) {
-        if (!Event->HasTimer() && Event->EndTime() + Setup.EPGLinger * 60 + 3600 < Time) // adding one hour for safety
+        if (!Event->HasTimer() && Event->EndTime() + Setup.EPGLinger * 60 < Time)
            DelEvent(Event);
         else
            break;
@@ -1141,9 +1140,11 @@
 bool cSchedule::Read(FILE *f, cSchedules *Schedules)
 {
   if (Schedules) {
+     int Line = 0;
      cReadLine ReadLine;
      char *s;
      while ((s = ReadLine.Read(f)) != NULL) {
+           Line++;
            if (*s == 'C') {
               s = skipspace(s + 1);
               char *p = strchr(s, ' ');
@@ -1153,7 +1154,7 @@
                  tChannelID channelID = tChannelID::FromString(s);
                  if (channelID.Valid()) {
                     if (cSchedule *p = Schedules->AddSchedule(channelID)) {
-                       if (!cEvent::Read(f, p))
+                       if (!cEvent::Read(f, p, Line))
                           return false;
                        p->Sort();
                        }
@@ -1165,7 +1166,7 @@
                  }
               }
            else {
-              esyslog("ERROR: unexpected tag while reading EPG data: %s", s);
+              esyslog("ERROR: unexpected tag in line %d while reading EPG data: %s", Line, s);
               return false;
               }
            }
diff -ruN vdr-2.3.4/epg.h vdr-2.3.5/epg.h
--- vdr-2.3.4/epg.h	2017-04-02 13:22:21.000000000 +0200
+++ vdr-2.3.5/epg.h	2017-05-09 14:15:14.000000000 +0200
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.h 4.4 2017/04/02 11:22:21 kls Exp $
+ * $Id: epg.h 4.6 2017/05/09 12:15:14 kls Exp $
  */
 
 #ifndef __EPG_H
@@ -141,7 +141,7 @@
   cString ToDescr(void) const;
   void Dump(FILE *f, const char *Prefix = "", bool InfoOnly = false) const;
   bool Parse(char *s);
-  static bool Read(FILE *f, cSchedule *Schedule);
+  static bool Read(FILE *f, cSchedule *Schedule, int &Line);
   void FixEpgBugs(void);
   };
 
@@ -284,7 +284,7 @@
   virtual bool DropOutdated(cSchedule *Schedule, time_t SegmentStart, time_t SegmentEnd, uchar TableID, uchar Version) { return false; }
           ///< Takes a look at all EPG events between SegmentStart and SegmentEnd and
           ///< drops outdated events.
-  virtual bool BeginSegmentTransfer(const cChannel *Channel, bool Dummy) { return false; } // TODO remove obsolete Dummy
+  virtual bool BeginSegmentTransfer(const cChannel *Channel, bool Dummy) { return true; } // TODO remove obsolete Dummy
           ///< Called directly after IgnoreChannel() before any other handler method is called.
           ///< Designed to give handlers the possibility to prepare a database transaction.
           ///< If any EPG handler returns false in this function, it is assumed that
